<?php
/**
 *
 * @copyright Copyright (C) 2009 PunBB
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * @package vb_description
*/
/**
 * Получение текста первого поста по номеру топика.
 * @param Intager $topicId - номер топика.
*/
function get_first_post($topicId) {
   global $forum_db;
   $que = array(
      'SELECT'   => 'p.message',
      'FROM'      => 'posts AS p',
      'WHERE'      => 'p.id='.$topicId,
      'LIMIT'      =>0, 1
      );
   $sult = $forum_db->query_build($que) or error(__FILE__, __LINE__);
   $re = $forum_db->fetch_assoc($sult);
   return ($re['message']);
}
/**
 *Приведение к человекочитаемому виду переданного текста.
 * @param String $str - передаваемый текст.
*/
function FormatDescription ($str) {
   $str = trim(strip_tags(str_replace(array('[',']'), array('<','>'),  $str)));

$rules = array(
      '/(«|»|„|“|”|&quot;|&ldquo;|&rdquo;)/iu' => '"', //Не наши кавычки убираем
      '/(&ndash;|&minus;|–|−|—|—|—)/iu' => '-', //Не наши тире убираем
      '/([,.;:?!]*)\s*[\r\n]+/' => '.$1',//если в конце строки знака нет, считаем ее концом предложения, ставим точку.
      '/(.)$/' => '$1.',// Точка в конце
      '/([,.;:?!-])+/iu' => '$1', //знаки не должны повторяться
      '/\s*[-]\s+|\s+[-]\s*/iu' => ' — ', //дефис обрамленный пробелами - длинное тире
      '/\s+([,.;:?!\-\)\}\]])/iu' => '$1', //перед знаком не должно быть пробела
      '/([-\(\{\[])\s+/iu' => '$1', //после знака не должно быть пробела
      '/([,.;:?!\)\}\]])/iu' => '$1 ', //после знака должен быть пробел
      '/\"\s*([^"]+)\s*\"/iu'=> ' «$1» ',  //Расставляем Ёлки
      '/»\s([,.;:?!-])/iu'=> '»$1',  //после кавычки нет пробела, только если там знак
      '/(\s|\t)+|\"/iu' => ' ',//Два и более пробелов = один пробел.
      '/^\s+|\s+$/iu' => '',// Убираем пробел с хвоста и с головы и оставшиеся кавычки
      '/\s+([0-9]{2})[\s:.,!?-]+([0-9]{2})(\s+|[.?!,:]|$)/iu' => ' $1:$2$3', // время две группы по две цифры
      '/([a-z0-9а-я])\.\s(ru|com|рф|net|org|info[^a-zа-я])/iu' => '$1.$2', // адреса
      '/\s*([,.;:?!\-\)\}\]])/iu' => '$1', //еще раз перед знаком не должно быть пробела
   );
   return (preg_replace (array_keys($rules), $rules, $str));
}

function vb_clear_links($content)
{
   global $base_url;

   $patern = '/(https?:\/\/)?(www\.)?([-а-яa-zёЁцушщхъфырэчстью0-9_\.]{2,}\.)(рф|[a-z]{2,6})((\/[-а-яёЁцушщхъфырэчстьюa-z0-9_]{1,})?\/?([a-z0-9_-]{2,}\.[a-z]{2,6})?(\?[a-z0-9_]{2,}=[-0-9]{1,})?((\&[a-z0-9_]{2,}=[-0-9]{1,}){1,})?)/i';

   preg_match_all($patern, $content, $matches);

   for ($i = 0; $i < count($matches); $i++)
   {
      if (!empty($matches[0][$i]) && (stristr($matches[0][$i], $base_url) === false) )
      {
         $content = str_ireplace($matches[0][$i], '', $content);
      }
   }

   return $content;
}

/**
 *Подготовка текста для метатега Description.
 * @param String $str - обрабатываемый текст.
 * @param Intager $limit - Номинальая длина тега.
*/
function preparing($str, $limit = 300) {
   $str = trim(mb_substr($str, 0, intval($limit*1.5))); 
   $str = vb_clear_links($str);
   $str = FormatDescription($str);
   $pos = mb_strrpos($str, '. '); // определяем позиция последнего пробела
   $str = trim(mb_substr($str, 0, $pos +1)); // обрезаем переменную по определенно выше позиции, плюс точка.
   return ($str);
}


?>